// Copyright 2011, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Author: Tuti Andriani <my.verdantique@gmail.com>,
// Zhilu Chang <zhilu.chang@gmail.com>.


#include <gtest/gtest.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>
#include <cctype>
#include <algorithm>
#include <vector>
#include <utility>
#include "./McCaskillAlgorithm.h"


using std::cout;
using std::endl;
using std::cin;
using std::string;


int main(int argc, char** argv)
{
        // Compute the structure for an example sequence.
        McCaskillAlgorithm mc;
        // Remind user to enter a sequence of A,C,U,G if they did not.
        if ( argc < 2)
        {
                printf("Please input the sequence of A,C,U,G first!\n");
                return 0;
        }
        // Remind user to enter a structrue of the sequence if they did not do.
        if ( argc < 3)
        {
                printf("Please input a structure of the input sequence!\n");
                return 0;
        }

        {
                char com;
                bool _print;
                string sequence = argv[1];  // "GCACGACGC";
                string str_string = argv[2];

                std::vector<std::pair<int, int> > structure;
                mc.convertStructureString(str_string, structure);

                std::vector<std::pair<int, int> > result;

                mc.computeStructure(sequence, &result);
                printf("Input sequence: %s\n", sequence.c_str());

                float energy = mc.getEnergy(structure);
                float partition_function = mc.getPartitionFunction();
                float probability = energy/partition_function;

                printf("The probability of the input structure is %f%%\n",
probability*100);

                // output  of Matrix
                mc.printMatrix();
        }
        return 0;
}
