// Copyright 2010, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Author: Tuti Andriani <my.verdantique@gmail.com>,
// Zhilu Chang <zhilu.chang@gmail.com>.

#include <stdio.h>
#include <string>
#include <vector>
#include <utility>
#include "./NussinovAlgorithm.h"

using std::string;
using std::vector;
using std::pair;

int main(int argc, char** argv)
{
  // Compute the structure for an example sequence.
  NussinovAlgorithm na;
  if ( argc < 2)
  {
     printf("Please input the sequence of A,C,U,G first!\n");
     return 0;
  }
  // Remind user to enter a sequence of A,C,U,G if they did not.
  {
  char com;
  bool _print;
    string sequence = (string)argv[1];  // "GCACGACGC";
  vector<pair<int, int> > result;
  na.computeStructure(sequence, &result);

  // Output the result.
  printf("Input sequence: %s\n", sequence.c_str());
  printf("Resulting pairs: ");
  for (size_t i = 0; i < result.size(); ++i)
  {
    if (i > 0) printf(", ");
    printf("(%d,%d)", result[i].first, result[i].second);
  }
  printf("\n");
printf("Do you want to print out the Nussinov Matrix?(y/n)\n");
  scanf("%s", &com);
  if (com == 'y')
     _print = true;
  else
     _print = false;

  if (_print)
  na.printNussinovMatrix();
  }
}
