// Copyright 2010, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Author: Hannah Bast <bast>.

#include <gtest/gtest.h>
#include <vector>
#include <utility>
#include "./NussinovAlgorithm.h"

// _____________________________________________________________________________
TEST(NussinovAlgorithmTest, computeStructure)
{
  NussinovAlgorithm na;
  std::vector<std::pair<int, int> > result;
  na.computeStructure("ACGU", &result);
  ASSERT_EQ(2, result.size());
  ASSERT_EQ(0, result[0].first);
  ASSERT_EQ(3, result[0].second);
  ASSERT_EQ(1, result[1].first);
  ASSERT_EQ(2, result[1].second);

  result.clear();

  na.computeStructure("AUAU", &result);
  ASSERT_EQ(2, result.size());
  ASSERT_EQ(0, result[0].first);
  ASSERT_EQ(3, result[0].second);
  ASSERT_EQ(1, result[1].first);
  ASSERT_EQ(2, result[1].second);
}
