// Copyright 2011, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Author: Tuti Andriani <my.verdantique@gmail.com>,
// Zhilu Chang <zhilu.chang@gmail.com>.


#include <gtest/gtest.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>
#include <cctype>
#include <algorithm>
#include <vector>
#include <utility>
#include "./ZukerAlgorithm.h"


using std::cout;
using std::endl;
using std::cin;
using std::string;


int main(int argc, char** argv)
{
        // Compute the structure for an example sequence.
        ZukerAlgorithm za;
        // Remind user to enter a sequence of A,C,U,G if they did not.
        if ( argc < 2)
        {        printf("Please input the sequence of A,C,U,G first!\n");
        return 0;
        }

        // Remind user to enter a sequence of A,C,U,G if they did not do.
        {
                char com;
                bool _print;
                string sequence = argv[1];  // "GCACGACGC";

                std::vector<std::pair<int, int> > result;

                za.computeStructure(sequence, &result);
                printf("Input sequence: %s\n", sequence.c_str());

                // output  of Matrix
                za.printMatrix();

                printf("Do you want to print out the pairs?(y/n)\n");
                scanf("%s", &com);
                if (com == 'y')
                        _print = true;
                else
                        _print = false;

                if (_print)
                   {    printf("Resulting pairs: ");
                        for (size_t i = 0; i < result.size(); ++i)
                        {    if (i > 0) printf(", ");
                printf("(%d,%d)", result[i].first, result[i].second);
                        }
                    }
                printf("\n");


/*                // Output the result.
                printf("Input sequence: %s\n", sequence.c_str());
                printf("Resulting pairs: ");
  		
                for (size_t i = 0; i < result.size(); ++i) {
                        if (i > 0) printf(", ");
                        printf("(%d,%d)", result[i].first, result[i].second);
                }
                printf("\n");
                printf("Do you want to print out the Zuker Matrix?(y/n)\n");
                scanf("%s", &com);
                if (com == 'y')
                        _print = true;
                else
                        _print = false;

                if (_print)
                        za.printMatrix();
*/
       }
        return 0;
}
